/*!
 * echarts-extension-gmap 
 * @version 1.4.0
 * @author plainheart
 * 
 * MIT License
 * 
 * Copyright (c) 2020 Zhongxiang.Wang
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("echarts")):"function"==typeof define&&define.amd?define(["exports","echarts"],t):t(((e="undefined"!=typeof globalThis?globalThis:e||self).echarts=e.echarts||{},e.echarts.gmap={}),e.echarts)}(this,(function(e,t){"use strict";function o(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach((function(o){if("default"!==o){var n=Object.getOwnPropertyDescriptor(e,o);Object.defineProperty(t,o,n.get?n:{enumerable:!0,get:function(){return e[o]}})}})),t["default"]=e,Object.freeze(t)}var n=o(t);function r(e,t){this._gmap=e,this.dimensions=["lng","lat"],this._mapOffset=[0,0],this._api=t}var i,a=r.prototype,s=["echartsLayerZIndex","renderOnMoving"];function g(e,o){return o=o||[0,0],t.util.map([0,1],(function(t){var n=o[t],r=e[t]/2,i=[],a=[];return i[t]=n-r,a[t]=n+r,i[1-t]=a[1-t]=o[1-t],Math.abs(this.dataToPoint(i)[t]-this.dataToPoint(a)[t])}),this)}function p(e,t){var o=t.__overlayProjection;return o?o.fromLatLngToContainerPixel(e):new google.maps.Point(-Infinity,-Infinity)}a.dimensions=["lng","lat"],a.setZoom=function(e){this._zoom=e},a.setCenter=function(e){var t=new google.maps.LatLng(e[1],e[0]);this._center=p(t,this._gmap)},a.setMapOffset=function(e){this._mapOffset=e},a.setGoogleMap=function(e){this._gmap=e},a.getGoogleMap=function(){return this._gmap},a.dataToPoint=function(e){var t=p(new google.maps.LatLng(e[1],e[0]),this._gmap),o=this._mapOffset;return[t.x-o[0],t.y-o[1]]},a.pointToData=function(e){var t=this._mapOffset,o=function(e,t){var o=t.__overlayProjection;if(!o)return new google.maps.Point(-Infinity,-Infinity);return o.fromContainerPixelToLatLng(e)}(new google.maps.Point(e[0]+t[0],e[1]+t[1]),this._gmap);return[o.lng(),o.lat()]},a.getViewRect=function(){var e=this._api;return new t.graphic.BoundingRect(0,0,e.getWidth(),e.getHeight())},a.getRoamTransform=function(){return t.matrix.create()},a.prepareCustoms=function(e){var o=this.getViewRect();return{coordSys:{type:"gmap",x:o.x,y:o.y,width:o.width,height:o.height},api:{coord:t.util.bind(this.dataToPoint,this),size:t.util.bind(g,this)}}},r.dimensions=a.dimensions,r.create=function(e,o){var n,a=o.getDom();e.eachComponent("gmap",(function(e){var g=o.getZr().painter,p=g.getViewportRoot();if("undefined"==typeof google||"undefined"==typeof google.maps||"undefined"==typeof google.maps.Map)throw new Error("It seems that Google Map API has not been loaded completely yet.");if(i=i||function(){function e(e,t){this._root=e,this.setMap(t)}return e.prototype=new google.maps.OverlayView,e.prototype.onAdd=function(){var e=this.getMap();e.__overlayProjection=this.getProjection(),e.getDiv().querySelector(".gm-style > div").appendChild(this._root)},e.prototype.draw=function(){google.maps.event.trigger(this.getMap(),"gmaprender")},e.prototype.onRemove=function(){this._root.parentNode.removeChild(this._root),this._root=null},e.prototype.setZIndex=function(e){this._root.style.zIndex=e},e.prototype.getZIndex=function(){return this._root.style.zIndex},e}(),n)throw new Error("Only one google map component can exist");var l=e.getGoogleMap();if(!l){var c=a.querySelector(".ec-extension-google-map");c&&(p.style.left="0px",p.style.top="0px",p.style.width="100%",p.style.height="100%",a.removeChild(c)),(c=document.createElement("div")).className="ec-extension-google-map",c.style.cssText="position:absolute;top:0;left:0;right:0;bottom:0;",a.appendChild(c);var d=t.util.clone(e.get()),f=d.echartsLayerZIndex;t.util.each(s,(function(e){delete d[e]}));var m=d.center;t.util.isArray(m)&&(d.center={lng:m[0],lat:m[1]}),l=new google.maps.Map(c,d),e.setGoogleMap(l),e.__projectionChangeListener&&e.__projectionChangeListener.remove(),e.__projectionChangeListener=google.maps.event.addListener(l,"projection_changed",(function(){var t=e.getEChartsLayer();t&&t.setMap(null);var o=new i(p,l);o.setZIndex(f),e.setEChartsLayer(o)})),g.getViewportRootOffset=function(){return{offsetLeft:0,offsetTop:0}}}var u=[null!=(m=e.get("center")).lng?m.lng:m[0],null!=m.lat?m.lat:m[1]],h=e.get("zoom");if(m&&h){var y=l.getCenter(),v=l.getZoom();if(e.centerOrZoomChanged([y.lng(),y.lat()],v)){var _=new google.maps.LatLng(u[1],u[0]);l.setOptions({center:_,zoom:h})}}(n=new r(l,o)).setMapOffset(e.__mapOffset||[0,0]),n.setZoom(h),n.setCenter(u),e.coordinateSystem=n})),e.eachSeries((function(e){"gmap"===e.get("coordinateSystem")&&(e.coordinateSystem=n)}))},n.extendComponentModel({type:"gmap",setGoogleMap:function(e){this.__gmap=e},getGoogleMap:function(){return this.__gmap},setEChartsLayer:function(e){this.__echartsLayer=e},getEChartsLayer:function(){return this.__echartsLayer},setCenterAndZoom:function(e,t){this.option.center=e,this.option.zoom=t},centerOrZoomChanged:function(e,t){var o,n,r=this.option;return o=e,n=r.center,!(o&&n&&o[0]===n[0]&&o[1]===n[1]&&t===r.zoom)},defaultOption:{center:{lat:39.90923,lng:116.397428},zoom:5,roam:!0,echartsLayerZIndex:2e3,renderOnMoving:!0}}),n.extendComponentView({type:"gmap",render:function(e,t,o){var r=!0,i=e.getGoogleMap(),a=o.getZr().painter.getViewportRoot(),s=e.coordinateSystem,g=i.getDiv(),p=e.get("renderOnMoving"),l=g.clientWidth,c=g.clientHeight;i.setOptions({gestureHandling:e.get("roam")?"auto":"none"});var d=function(){if(!r){var t=g.clientWidth,n=g.clientHeight;if(t!==l||n!==c)return f.call(this);var i=[-parseInt(g.style.left,10)||0,-parseInt(g.style.top,10)||0];a.style.left=i[0]+"px",a.style.top=i[1]+"px",s.setMapOffset(i),e.__mapOffset=i,o.dispatchAction({type:"gmapRoam",animation:{duration:0}})}},f=function(){n.getInstanceByDom(o.getDom()).resize()};this._oldRenderHandler&&this._oldRenderHandler.remove(),p||(d=n.throttle(d,100,!0),f=n.throttle(f,100,!0)),this._oldRenderHandler=google.maps.event.addListener(i,"gmaprender",d),r=!1},dispose:function(e,t){this._oldRenderHandler&&this._oldRenderHandler.remove(),this._oldRenderHandler=null;var o=e.getComponent("gmap");if(o){var n=o.getGoogleMap();if(n){delete n.__overlayProjection,google.maps.event.clearInstanceListeners(n);var r=n.getDiv();r.parentNode&&r.parentNode.removeChild(r)}o.setGoogleMap(null),o.setEChartsLayer(null),o.coordinateSystem&&(o.coordinateSystem.setGoogleMap(null),o.coordinateSystem=null)}}}),n.registerCoordinateSystem("gmap",r),n.registerAction({type:"gmapRoam",event:"gmapRoam",update:"updateLayout"},(function(e,t){t.eachComponent("gmap",(function(e){var t=e.getGoogleMap(),o=t.getCenter();e.setCenterAndZoom([o.lng(),o.lat()],t.getZoom())}))})),e.name="echarts-extension-gmap",e.version="1.4.0",Object.defineProperty(e,"__esModule",{value:!0})}));
